﻿using System.IO;
using System.Text;
using System.Xml.Serialization;

namespace XSD
{
    /// <summary>
    /// XmlHelper 的摘要描述
    /// </summary>
    public class XmlHelper
    {
        public XmlHelper()
        {
            //
            // TODO: 在此加入建構函式的程式碼
            //
        }



        public string Serialize<T>(T dataToSerialize)
        {
            try
            {
                var serializer = new XmlSerializer(typeof(T));
                //// 不聲明頭
                //XmlWriterSettings settings = new XmlWriterSettings();
                //settings.Indent = true;
                //settings.NewLineChars = "";
                ////settings.Encoding = encoding;
                ////settings.IndentChars = "    ";

                //// 不聲明頭
                //settings.OmitXmlDeclaration = true;


                // 強制指定新的命名空間，這裡設置為空
                XmlSerializerNamespaces namespaces = new XmlSerializerNamespaces();
                namespaces.Add(string.Empty, string.Empty);

                Utf8StringWriter stringwriter = new Utf8StringWriter();
                serializer.Serialize(stringwriter, dataToSerialize, namespaces);
                return stringwriter.ToString();
            }
            catch
            {
                throw;
            }
        }

        public T Deserialize<T>(string xmlText)
        {
            try
            {
                var stringReader = new System.IO.StringReader(xmlText);
                var serializer = new XmlSerializer(typeof(T));
                return (T)serializer.Deserialize(stringReader);
            }
            catch
            {
                throw;
            }
        }


        public class Utf8StringWriter : StringWriter
        {

            public override Encoding Encoding
            {
                get
                {
                    return Encoding.UTF8;
                }
            }
        }
    }
}
